function value = interpolateGridValue( grid, grid_pos )

grid_pos_lo = floor(grid_pos);
grid_pos_hi = ceil(grid_pos);

w_hi_hi = (grid_pos(1)-grid_pos_lo(1))*(grid_pos(2)-grid_pos_lo(2));
w_hi_lo = (grid_pos(1)-grid_pos_lo(1))*(grid_pos_hi(2)-grid_pos(2));
w_lo_hi = (grid_pos_hi(1)-grid_pos(1))*(grid_pos(2)-grid_pos_lo(2));
w_lo_lo = (grid_pos_hi(1)-grid_pos(1))*(grid_pos_hi(2)-grid_pos(2));

v_lo_lo = grid( int32( grid_pos_lo(1) ), int32( grid_pos_lo(2) ) );
v_lo_hi = grid( int32( grid_pos_lo(1) ), int32( grid_pos_hi(2) ) );
v_hi_lo = grid( int32( grid_pos_hi(1) ), int32( grid_pos_lo(2) ) );
v_hi_hi = grid( int32( grid_pos_hi(1) ), int32( grid_pos_hi(2) ) );

weightsum = 0;
value = 0;

if v_lo_lo ~= 0
    weightsum = weightsum + w_lo_lo;
    value = value + w_lo_lo*v_lo_lo;
end

if v_lo_hi ~= 0
    weightsum = weightsum + w_lo_hi;
    value = value + w_lo_hi*v_lo_hi;
end

if v_hi_lo ~= 0
    weightsum = weightsum + w_hi_lo;
    value = value + w_hi_lo*v_hi_lo;
end

if v_hi_hi ~= 0
    weightsum = weightsum + w_hi_hi;
    value = value + w_hi_hi*v_hi_hi;
end

value = value / weightsum;

end


